<?php

/**
 * gen_archivos_siif_nacion actions.
 *
 * @package    nomina
 * @subpackage gen_archivos_siif_nacion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class gen_archivos_siif_nacionActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.NUM_DOC';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //whereBanco
            if (isset($request['id_bn'])) {
                $whereBanco = " AND tab0.id_bn = " . $request['id_bn'];
            } else {
                $whereBanco = ' ';
            }
            //Tipo Cuenta
            if (isset($request['tipo_cuenta'])) {
                $whereTipoCuenta = " AND tab0.tipo_cuenta = " . $request['tipo_cuenta'];
            } else {
                $whereTipoCuenta = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
             * Se agrega campo pago_func para tenerlo en cuenta en el calculo del neto a pagar - 20130731
             * Validacion para no traer las personas retiradas en fechas anteriores al nuevo periodo - 20141202
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.* ,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) as periodo


from(
    
    select 
    id_periodo,
    case when estado = 0 then null else id_bn end as id_bn, 
    case when estado = 0 then null else id end as tipo_cuenta,
    id_tipo_doc, 
    codigo_siif,
    num_doc,
    nombre_apellido,
    case when estado = 0 then 'CH' else 'AC' end as medio_pago,
    case when estado = 0 then null else banco end as banco,
    codigo_ach,
    descripcion,
    case when estado = 0 then null else nombre_corto end as nombre_corto,
    case when estado = 0 then null else num_cuenta end as num_cuenta,
    sum(nvl(valor_dev,0)) as valor_dev, 
    sum(nvl(valor_ded,0)) as valor_ded, 
    sum(nvl(valor,0)) as valor
        
    from(
    
        select 
        tab1.num_doc,tab6.nombre_apellido,tab3.codigo||' - '||tab3.descripcion as banco, tab3.codigo_ach, 
        tab2.num_cuenta, 
        nvl(tab2.estado,0) as estado,
        case when tab5.operador = 1 then tab1.valor_liquidado else (tab1.valor_liquidado * -1) end as valor,
        case when tab5.operador = 1 then tab1.valor_liquidado else 0 end as valor_dev,
        case when tab5.operador = 0 then tab1.valor_liquidado else 0 end as valor_ded,
        tab1.id_periodo,
        tab1.id_tipo_doc, tab3.id_bn, 
        tab4.id,
        tab4.descripcion,
        tab4.nombre_corto,
        tab7.codigo_siif
        from no_liquida_nomina tab1
        
        left join no_concep_nomina tab5 on tab5.id_concep_nomina = tab1.id_concep_nomina
        left join no_datos_funcionario_v tab6  on tab6.id_tipo_doc = tab1.id_tipo_doc and tab6.num_doc = tab1.num_doc
        
        --join no_pago_func tab2 on tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        left join (
          SELECT
           aut.*,
           ROW_NUMBER() OVER (
            partition by aut.num_doc
            ORDER BY aut.num_doc asc, aut.fecha_terminacion desc
           ) AS rn
          from no_pago_func aut
        )tab2
        on tab1.id_tipo_doc = tab2.id_tipo_doc and tab1.num_doc = tab2.num_doc
        and tab2.rn = 1
        
        left join ts_bn tab3 on tab3.id_bn = tab2.id_bn
        left join ts_tc tab4 on tab4.id = tab2.tipo_cuenta
        join tipo_documento tab7 on tab7.id_tipo_doc = tab1.id_tipo_doc
        
        where 
        tab1.id_periodo = $periodo_filtro
        and tab5.pago_func = 1
    
    )
    group by 
    codigo_siif,
    num_doc,nombre_apellido,banco,codigo_ach,
    num_cuenta,descripcion,id_periodo, 
    id_tipo_doc, id_bn, id, nombre_corto, estado

)tab0

where 
1 = 1
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereBanco $whereTipoCuenta

and tab0.num_doc not in (
 select nom.num_doc from no_nombramiento_v nom 
  where nom.fecha_retiro is not null
  and (select no_periodo.fecha_ini from no_periodo 
        where id_periodo = $periodo_filtro) > trunc(last_day( nom.fecha_termina ))
)
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            /*
             * Se agrega campo pago_func para tenerlo en cuenta en el calculo del neto a pagar - 20130731
             * Validacion para no traer las personas retiradas en fechas anteriores al nuevo periodo - 20141202
             */
            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.* ,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) as periodo


from(
    
    select 
    id_periodo,
    case when estado = 0 then null else id_bn end as id_bn, 
    case when estado = 0 then null else id end as tipo_cuenta,
    id_tipo_doc, 
    codigo_siif,
    num_doc,
    nombre_apellido,
    case when estado = 0 then 'CH' else 'AC' end as medio_pago,
    case when estado = 0 then null else banco end as banco,
    codigo_ach,
    descripcion,
    case when estado = 0 then null else nombre_corto end as nombre_corto,
    case when estado = 0 then null else num_cuenta end as num_cuenta,
    sum(nvl(valor_dev,0)) as valor_dev, 
    sum(nvl(valor_ded,0)) as valor_ded, 
    sum(nvl(valor,0)) as valor
        
    from(
    
        select 
        tab1.num_doc,tab6.nombre_apellido,tab3.codigo||' - '||tab3.descripcion as banco, tab3.codigo_ach, 
        tab2.num_cuenta, 
        nvl(tab2.estado,0) as estado,
        case when tab5.operador = 1 then tab1.valor_liquidado else (tab1.valor_liquidado * -1) end as valor,
        case when tab5.operador = 1 then tab1.valor_liquidado else 0 end as valor_dev,
        case when tab5.operador = 0 then tab1.valor_liquidado else 0 end as valor_ded,
        tab1.id_periodo,
        tab1.id_tipo_doc, tab3.id_bn, 
        tab4.id,
        tab4.descripcion,
        tab4.nombre_corto,
        tab7.codigo_siif
        from no_liquida_nomina tab1
        
        left join no_concep_nomina tab5 on tab5.id_concep_nomina = tab1.id_concep_nomina
        left join no_datos_funcionario_v tab6  on tab6.id_tipo_doc = tab1.id_tipo_doc and tab6.num_doc = tab1.num_doc
        
        --join no_pago_func tab2 on tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
        left join (
          SELECT
           aut.*,
           ROW_NUMBER() OVER (
            partition by aut.num_doc
            ORDER BY aut.num_doc asc, aut.fecha_terminacion desc
           ) AS rn
          from no_pago_func aut
        )tab2
        on tab1.id_tipo_doc = tab2.id_tipo_doc and tab1.num_doc = tab2.num_doc
        and tab2.rn = 1
        
        left join ts_bn tab3 on tab3.id_bn = tab2.id_bn
        left join ts_tc tab4 on tab4.id = tab2.tipo_cuenta
        join tipo_documento tab7 on tab7.id_tipo_doc = tab1.id_tipo_doc
        
        where 
        tab1.id_periodo = $periodo_filtro
        and tab5.pago_func = 1
    
    )
    group by 
    codigo_siif,
    num_doc,nombre_apellido,banco,codigo_ach,
    num_cuenta,descripcion,id_periodo, 
    id_tipo_doc, id_bn, id, nombre_corto, estado

)tab0

where 
1 = 1
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereBanco $whereTipoCuenta

and tab0.num_doc not in (
 select nom.num_doc from no_nombramiento_v nom 
  where nom.fecha_retiro is not null
  and (select no_periodo.fecha_ini from no_periodo 
        where id_periodo = $periodo_filtro) > trunc(last_day( nom.fecha_termina ))
)
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[gen_archivos_siif_nacion] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("[gen_archivos_siif_nacion] ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
